//+------------------------------------------------------------------+
//|                                            TrendFletAnalysis.mq4 |
//|                                      Copyright  2008, komposter |
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, komposter"
#property link      "mailto:komposterius@mail.ru"

extern datetime	DateStart				= 0;				//   (0 -   )
extern datetime	DateEnd					= 0;				//   (0 -   )

extern int			ind_Points				= 700;			//  
extern double		ind_Percent				= 0.0;			//  

extern color		colorText				= White; 		//  
extern double		sizeText					= 9; 				//  

extern int			TrendFlet_Width		= 2;				//   /
extern int			TrendFlet_Style		= STYLE_SOLID;	//   / (   = 1)
extern color		Flet_Color				= White; 		//   
extern color		TrendUP_Color			= Lime;			//    
extern color		TrendDN_Color			= Red;			//    
extern int			ZigZag_Width			= 1;				//   
extern int			ZigZag_Style			= STYLE_DASH;	//    (   = 1)
extern color		ZigZagUP_Color			= DeepSkyBlue;	//     
extern color		ZigZagDN_Color			= DeepSkyBlue;	//     

int bar_start = 0, bar_end = 0, bars_count = 0;

int trends_count = 0, flets_count = 0;
int trend_summ_width = 0, flet_summ_width = 0, trend_min_width = 99999, trend_max_width = 0, flet_min_width = 99999, flet_max_width = 0;
int trend_summ_height = 0, flet_summ_height = 0, trend_min_height = 99999, trend_max_height = 0, flet_min_height = 99999, flet_max_height = 0;

int trend_series_count = 0;
int trend_series_parts_count = 0, trend_series_parts_summ_width = 0, trend_series_parts_summ_height = 0;
int trend_series_maxP_parts_count = 0, trend_series_maxP_height = 0, trend_series_maxP_width = 0;
int trend_series_maxW_parts_count = 0, trend_series_maxW_height = 0, trend_series_maxW_width = 0;
int trend_series_maxH_parts_count = 0, trend_series_maxH_height = 0, trend_series_maxH_width = 0;

int flet_series_count = 0;
int flet_series_parts_count = 0, flet_series_parts_summ_width = 0, flet_series_parts_summ_height = 0;
int flet_series_maxP_parts_count = 0, flet_series_maxP_height = 0, flet_series_maxP_width = 0;
int flet_series_maxW_parts_count = 0, flet_series_maxW_height = 0, flet_series_maxW_width = 0;
int flet_series_maxH_parts_count = 0, flet_series_maxH_height = 0, flet_series_maxH_width = 0;

int init()
{
	Comment( WindowExpertName(), "  (copyright  2008, komposter)", "  ", Symbol(), " ", strPeriod() );

	//    
	start();

	HideTestIndicators(true);

	return(0);
}

int deinit()
{
	//    
	if ( !IsTesting() )
	{
		string name;
		for ( int o = ObjectsTotal()-1; o >= 0; o -- )
		{
			name = ObjectName(o);
			if ( StringFind( name, "TFA_" ) == 0 ) ObjectDelete( name );
		}
		WindowRedraw();
	}
	return(0);
}

int start()
{
	trends_count = 0; flets_count = 0;
	trend_summ_width = 0; flet_summ_width = 0; trend_min_width = 99999; trend_max_width = 0; flet_min_width = 99999; flet_max_width = 0;
	trend_summ_height = 0; flet_summ_height = 0; trend_min_height = 99999; trend_max_height = 0; flet_min_height = 99999; flet_max_height = 0;

	trend_series_count = 0;
	trend_series_parts_count = 0; trend_series_parts_summ_width = 0; trend_series_parts_summ_height = 0;
	trend_series_maxP_parts_count = 0; trend_series_maxP_height = 0; trend_series_maxP_width = 0;
	trend_series_maxW_parts_count = 0; trend_series_maxW_height = 0; trend_series_maxW_width = 0;
	trend_series_maxH_parts_count = 0; trend_series_maxH_height = 0; trend_series_maxH_width = 0;

	flet_series_count = 0;
	flet_series_parts_count = 0; flet_series_parts_summ_width = 0; flet_series_parts_summ_height = 0;
	flet_series_maxP_parts_count = 0; flet_series_maxP_height = 0; flet_series_maxP_width = 0;
	flet_series_maxW_parts_count = 0; flet_series_maxW_height = 0; flet_series_maxW_width = 0;
	flet_series_maxH_parts_count = 0; flet_series_maxH_height = 0; flet_series_maxH_width = 0;

	double temp, z, h, l, pre_z, pre_h, pre_l; string draw_name = "";
	int pre_i = 0, pre_i_zz;

	//   
	if ( DateStart < 1 )
		bar_start = Bars-1;
	else
		bar_start = iBarShift( Symbol(), Period(), DateStart );

	//   
	if ( DateEnd < 1 )
		bar_end = 0;
	else
		bar_end = iBarShift( Symbol(), Period(), DateEnd );

	// -  
	bars_count = bar_start - bar_end;

	for ( int i = bar_start; i >= bar_end; i -- )
	{
		//    
		temp = iCustom( NULL, 0, "ZZm-fx-txt", ind_Points, ind_Percent, true, false, DeepSkyBlue, Yellow, false, 0, i );

		if ( draw_name != "" )
		{
			ObjectSet( draw_name, OBJPROP_TIME2, Time[i] );
			int find_res = StringFind( draw_name, "UP" );
			if (
					( find_res >= 0 && ObjectGet( draw_name, OBJPROP_PRICE2 ) > Low [i] )
					||
					( find_res <  0 && ObjectGet( draw_name, OBJPROP_PRICE2 ) < High[i] )
				)
			{
				count( i, pre_i, z, l, h, pre_z, pre_l, pre_h );

				//    
				pre_i = i;
				pre_z = z;
				pre_h = h;
				pre_l = l;

				draw_name = "";

				if ( i == bar_end+1 ) trade( find_res );
			}
		}

		//   
		if ( temp < Point || temp == EMPTY_VALUE ) continue;

		z = temp;
		//     
		h = iCustom( NULL, 0, "ZZm-fx-txt", ind_Points, ind_Percent, true, false, DeepSkyBlue, Yellow, false, 1, i );
		l = iCustom( NULL, 0, "ZZm-fx-txt", ind_Points, ind_Percent, true, false, DeepSkyBlue, Yellow, false, 2, i );

		//      ,     
		if ( pre_i > 0 )
		{
			if ( z > pre_z )
				draw_name = "TFA_"+TimeToStr( Time[pre_i_zz] )+"UP";
			else
				draw_name = "TFA_"+TimeToStr( Time[pre_i_zz] )+"DN";

			//   (   )
			ObjectCreate( draw_name+"-zz", OBJ_TREND, 0, Time[pre_i_zz], pre_z, Time[i], z );
			ObjectMove	( draw_name+"-zz", 0, Time[pre_i_zz], pre_z );
			ObjectMove	( draw_name+"-zz", 1, Time[i], z );
			ObjectSet	( draw_name+"-zz", OBJPROP_RAY, false );
			ObjectSet	( draw_name+"-zz", OBJPROP_WIDTH, ZigZag_Width );
			ObjectSet	( draw_name+"-zz", OBJPROP_STYLE, ZigZag_Style );

			//  / (    )
			ObjectCreate( draw_name, OBJ_TREND, 0, Time[pre_i], 0.0, Time[i], 0.0 );
			ObjectSet	( draw_name, OBJPROP_TIME1, Time[pre_i] );
			ObjectSet	( draw_name, OBJPROP_TIME2, Time[i] );
			ObjectSet	( draw_name, OBJPROP_RAY, false );
			ObjectSet	( draw_name, OBJPROP_WIDTH, TrendFlet_Width );
			ObjectSet	( draw_name, OBJPROP_STYLE, TrendFlet_Style );

			//    
			if ( z > pre_z )
			{
				//     /
				ObjectSet( draw_name, OBJPROP_PRICE1, pre_h );
				ObjectSet( draw_name, OBJPROP_PRICE2, l );

				//   
				ObjectSet( draw_name+"-zz", OBJPROP_COLOR, ZigZagUP_Color );

				//    -   
				if ( l > pre_h )
				{
					//   
					ObjectSet( draw_name, OBJPROP_COLOR, TrendUP_Color );
				}
				//    (   ) -  
				else
				{
					//   
					ObjectSet( draw_name, OBJPROP_COLOR, Flet_Color );
				}
			}
			//    
			else
			{
				//     /
				ObjectSet( draw_name, OBJPROP_PRICE1, pre_l );
				ObjectSet( draw_name, OBJPROP_PRICE2, h );

				//   
				ObjectSet( draw_name+"-zz", OBJPROP_COLOR, ZigZagDN_Color );

				//    -   
				if ( h < pre_l )
				{
					//   
					ObjectSet	( draw_name, OBJPROP_COLOR, TrendDN_Color );
				}
				//    (   ) -  
				else
				{
					//   
					ObjectSet( draw_name, OBJPROP_COLOR, Flet_Color );
				}
			}

			pre_i_zz = i;
		}
		else
		{
			//   
			pre_i = i;
			pre_z = z;
			pre_h = h;
			pre_l = l;
			pre_i_zz = i;
		}
	}

	flet_series_close();
	trend_series_close();
	count( i, pre_i, z, l, h, pre_z, pre_l, pre_h );

	double trend_perc = trend_summ_width/(bars_count/100.0);
	double flet_perc  = flet_summ_width /(bars_count/100.0);
	double trend_perc_height = trend_summ_height/((trend_summ_height+flet_summ_height)/100.0);
	double flet_perc_height  = flet_summ_height /((trend_summ_height+flet_summ_height)/100.0);

	string head[4][2];
	head[0][0]	= "Start Date:";			head[0][1]	= TimeToStr( Time[bar_start] );
	head[1][0]	= "End Date:";				head[1][1]	= TimeToStr( Time[bar_end  ] );
	head[2][0]	= "Indicator Points:";	head[2][1]	= ind_Points;
	head[3][0]	= "Indicator Percent:";	head[3][1]	= DoubleToStr( ind_Percent, 1 );

	int head_size = ArrayRange( head, 0 );
	for ( int r = 0; r < head_size; r ++ )
	{
		_LabelCreate( "TFA_label_h_"+r+"_name", 10, 13+r*14, head[r][0] );
		_LabelCreate( "TFA_label_h_"+r+"_val", 200, 13+r*14, head[r][1] );
	}

	string param[14][4];
	param[0][0]		= " ";							param[0][1]		= "Trend";																param[0][2]		= "Flet";																param[0][3]		= "All";
	param[1][0]		= "Count";						param[1][1]		= trends_count;														param[1][2]		= flets_count;															param[1][3]		= trends_count+flets_count;
	param[2][0]		= " ";							param[2][1]		= " ";																	param[2][2]		= " ";																	param[2][3]		= " ";
	param[3][0]		= "Summ Width (bars)";		param[3][1]		= trend_summ_width;													param[3][2]		= flet_summ_width;													param[3][3]		= trend_summ_width+flet_summ_width;
	param[4][0]		= "Summ Width (%)";			param[4][1]		= DoubleToStr( trend_perc, 1 );									param[4][2]		= DoubleToStr( flet_perc , 1 );									param[4][3]		= 100;
	param[5][0]		= "Min Width (bars)";		param[5][1]		= trend_min_width;													param[5][2]		= flet_min_width;														param[5][3]		= DoubleToStr( MathMin( trend_min_width, flet_min_width ), 0 );
	param[6][0]		= "Max Width (bars)";		param[6][1]		= trend_max_width;													param[6][2]		= flet_max_width;														param[6][3]		= DoubleToStr( MathMax( trend_max_width, flet_max_width ), 0 );
	param[7][0]		= "Ave Width (bars)";		param[7][1]		= DoubleToStr( 1.0*trend_summ_width/trends_count, 1 );	param[7][2]		= DoubleToStr( 1.0*flet_summ_width/flets_count, 1 );		param[7][3]		= DoubleToStr( 1.0*(trend_summ_width+flet_summ_width)/(trends_count+flets_count), 1 );	
	param[8][0]		= " ";							param[8][1]		= " ";																	param[8][2]		= " ";																	param[8][3]		= " ";
	param[9][0]		= "Summ Height (points)";	param[9][1]		= trend_summ_height;													param[9][2]		= flet_summ_height;													param[9][3]		= trend_summ_height+flet_summ_height;
	param[10][0]	= "Summ Height (%)";			param[10][1]	= DoubleToStr( trend_perc_height, 1 );							param[10][2]	= DoubleToStr( flet_perc_height, 1 );							param[10][3]	= 100;
	param[11][0]	= "Min Height (points)";	param[11][1]	= trend_min_height;													param[11][2]	= flet_min_height;													param[11][3]	= DoubleToStr( MathMin( trend_min_height, flet_min_height ), 0 );
	param[12][0]	= "Max Height (points)";	param[12][1]	= trend_max_height;													param[12][2]	= flet_max_height;													param[12][3]	= DoubleToStr( MathMax( trend_max_height, flet_max_height ), 0 );
	param[13][0]	= "Ave Height (points)";	param[13][1]	= DoubleToStr( 1.0*trend_summ_height/trends_count, 1 );	param[13][2]	= DoubleToStr( 1.0*flet_summ_height/flets_count, 1 );		param[13][3]	= DoubleToStr( 1.0*(trend_summ_height+flet_summ_height)/(trends_count+flets_count), 1 );	

	for ( r = 0; r < 14; r ++ )
	{
		_LabelCreate( "TFA_label_"+r+"_name", 10, 20+head_size*14+r*14, param[r][0] );
		for ( int c = 1; c < 4; c ++ )
		{
			_LabelCreate( "TFA_label_"+r+"_"+c, 150+c*50, 20+head_size*14+r*14, param[r][c] );
		}
	}

	string series[12][4];
	series[0][0]		= "Max parts count series";				series[0][1]		= " ";																	series[0][2]		= " ";																	series[0][3]		= " ";
	series[1][0]		= "   parts count";							series[1][1]		= trend_series_maxP_parts_count;									series[1][2]		= flet_series_maxP_parts_count;									series[1][3]		= " ";
	series[2][0]		= "   width (bars)";							series[2][1]		= trend_series_maxP_width;											series[2][2]		= flet_series_maxP_width;											series[2][3]		= " ";
	series[3][0]		= "   height (points)";						series[3][1]		= trend_series_maxP_height;										series[3][2]		= flet_series_maxP_height;											series[3][3]		= " ";
	series[4][0]		= "Max width series";						series[4][1]		= " ";																	series[4][2]		= " ";																	series[4][3]		= " ";
	series[5][0]		= "   parts count";							series[5][1]		= trend_series_maxW_parts_count;									series[5][2]		= flet_series_maxW_parts_count;									series[5][3]		= " ";
	series[6][0]		= "   width (bars)";							series[6][1]		= trend_series_maxW_width;											series[6][2]		= flet_series_maxW_width;											series[6][3]		= " ";
	series[7][0]		= "   height (points)";						series[7][1]		= trend_series_maxW_height;										series[7][2]		= flet_series_maxW_height;											series[7][3]		= " ";
	series[8][0]		= "Max height series";						series[8][1]		= " ";																	series[8][2]		= " ";																	series[8][3]		= " ";
	series[9][0]		= "   parts count";							series[9][1]		= trend_series_maxH_parts_count;									series[9][2]		= flet_series_maxH_parts_count;									series[9][3]		= " ";
	series[10][0]		= "   width (bars)";							series[10][1]		= trend_series_maxH_width;											series[10][2]		= flet_series_maxH_width;											series[10][3]		= " ";
	series[11][0]		= "   height (points)";						series[11][1]		= trend_series_maxH_height;										series[11][2]		= flet_series_maxH_height;											series[11][3]		= " ";


	for ( r = 0; r < 12; r ++ )
	{
		_LabelCreate( "TFA_label_"+r+"_name_s", 10, 20+head_size*14+14*15+r*14, series[r][0] );
		for ( c = 1; c < 4; c ++ )
		{
			_LabelCreate( "TFA_label_"+r+"_"+c+"_s", 150+c*50, 20+head_size*14+14*15+r*14, series[r][c] );
		}
	}

	WindowRedraw();

	return(0);
}

void count( int i, int pre_i, double z, double l, double h, double pre_z, double pre_l, double pre_h )
{
	//    
	int width = pre_i-i, height;

	//    
	if ( z > pre_z )
	{
		//   /  
		height = MathAbs( l - pre_h ) / Point;

		//    -   
		if ( l > pre_h )
		{
			//     
			trends_count ++;
			trend_summ_width += width;
			trend_min_width = MathMin( trend_min_width, width );
			trend_max_width = MathMax( trend_max_width, width );
			trend_summ_height += height;
			trend_min_height = MathMin( trend_min_height, height );
			trend_max_height = MathMax( trend_max_height, height );

			flet_series_close();
			trend_series_add( width, height );
		}
		//    (   ) -  
		else
		{
			//     
			flets_count ++;
			flet_summ_width += width;
			flet_min_width = MathMin( flet_min_width, width );
			flet_max_width = MathMax( flet_max_width, width );
			flet_summ_height += height;
			flet_min_height = MathMin( flet_min_height, height );
			flet_max_height = MathMax( flet_max_height, height );

			trend_series_close();
			flet_series_add( width, height );
		}
	}
	//    
	else
	{
		//   /  
		height = MathAbs( h - pre_l ) / Point;

		//    -   
		if ( h < pre_l )
		{
			//     
			trends_count ++;
			trend_summ_width += width;
			trend_min_width = MathMin( trend_min_width, width );
			trend_max_width = MathMax( trend_max_width, width );
			trend_summ_height += height;
			trend_min_height = MathMin( trend_min_height, height );
			trend_max_height = MathMax( trend_max_height, height );

			flet_series_close();
			trend_series_add( width, height );
		}
		//    (   ) -  
		else
		{
			//     
			flets_count ++;
			flet_summ_width += width;
			flet_min_width = MathMin( flet_min_width, width );
			flet_max_width = MathMax( flet_max_width, width );
			flet_summ_height += height;
			flet_min_height = MathMin( flet_min_height, height );
			flet_max_height = MathMax( flet_max_height, height );

			trend_series_close();
			flet_series_add( width, height );
		}
	}
}

void trend_series_add( int _width, int _height )
{
	trend_series_parts_count ++;							// - 
	trend_series_parts_summ_width += _width;			//   
	trend_series_parts_summ_height += _height;		//   
}

void flet_series_add( int _width, int _height )
{
	flet_series_parts_count ++;							// - 
	flet_series_parts_summ_width += _width;			//   
	flet_series_parts_summ_height += _height;		//   
}

void trend_series_close()
{
	if ( trend_series_parts_count < 1 ) return;

	trend_series_count ++;									//  

	//    (  )
	if ( trend_series_parts_count > trend_series_maxP_parts_count )
	{
		trend_series_maxP_parts_count = trend_series_parts_count;
		trend_series_maxP_height = trend_series_parts_summ_height;
		trend_series_maxP_width = trend_series_parts_summ_width;
	}

	//    (   )
	if ( trend_series_parts_summ_width > trend_series_maxW_width )
	{
		trend_series_maxW_parts_count = trend_series_parts_count;
		trend_series_maxW_height = trend_series_parts_summ_height;
		trend_series_maxW_width = trend_series_parts_summ_width;
	}

	//    (      )
	if ( trend_series_parts_summ_height > trend_series_maxH_height )
	{
		trend_series_maxH_parts_count = trend_series_parts_count;
		trend_series_maxH_height = trend_series_parts_summ_height;
		trend_series_maxH_width = trend_series_parts_summ_width;
	}

	trend_series_parts_count = 0;
	trend_series_parts_summ_width = 0;
	trend_series_parts_summ_height = 0;
}

void flet_series_close()
{
	if ( flet_series_parts_count < 1 ) return;

	flet_series_count ++;									//  

	//    (  )
	if ( flet_series_parts_count > flet_series_maxP_parts_count )
	{
		flet_series_maxP_parts_count = flet_series_parts_count;
		flet_series_maxP_height = flet_series_parts_summ_height;
		flet_series_maxP_width = flet_series_parts_summ_width;
	}

	//    (   )
	if ( flet_series_parts_summ_width > flet_series_maxW_width )
	{
		flet_series_maxW_parts_count = flet_series_parts_count;
		flet_series_maxW_height = flet_series_parts_summ_height;
		flet_series_maxW_width = flet_series_parts_summ_width;
	}

	//    (      )
	if ( flet_series_parts_summ_height > flet_series_maxH_height )
	{
		flet_series_maxH_parts_count = flet_series_parts_count;
		flet_series_maxH_height = flet_series_parts_summ_height;
		flet_series_maxH_width = flet_series_parts_summ_width;
	}

	flet_series_parts_count = 0;
	flet_series_parts_summ_width = 0;
	flet_series_parts_summ_height = 0;
}

void trade( int res )
{
	if ( !IsTesting() ) return;

	static int ticket = 0;

	if ( ticket > 0 )
	{
		if ( OrderSelect( ticket, SELECT_BY_TICKET ) )
		{
			if ( OrderClose( ticket, OrderLots(), OrderClosePrice(), 3, White ) ) ticket = 0;
		}
	}

	if ( res < 0 )
	{
		ticket = OrderSend( Symbol(), OP_BUY , 0.1, Ask, 3, 0.0, 0.0 );
	}
	else
	{
		ticket = OrderSend( Symbol(), OP_SELL, 0.1, Bid, 3, 0.0, 0.0 );
	}
}

void _LabelCreate ( string _Name, int _XDistance, int _YDistance, string _Text = " " )
{
	ObjectCreate	( _Name, OBJ_LABEL, 0, 0, 0 );
	ObjectSet		( _Name, OBJPROP_CORNER, 0 );
	ObjectSet		( _Name, OBJPROP_COLOR, colorText );
	ObjectSet		( _Name, OBJPROP_XDISTANCE, _XDistance );
	ObjectSet		( _Name, OBJPROP_YDISTANCE, _YDistance );
	ObjectSetText	( _Name, _Text, sizeText );
	GetLastError	();
}

string strPeriod()
{
	switch ( Period() )
	{
		case PERIOD_MN1: return("MN1");
		case PERIOD_W1:  return("W1");
		case PERIOD_D1:  return("D1");
		case PERIOD_H4:  return("H4");
		case PERIOD_H1:  return("H1");
		case PERIOD_M30: return("M30");
		case PERIOD_M15: return("M15");
		case PERIOD_M5:  return("M5");
		case PERIOD_M1:  return("M1");
		default:		     return("UnknownPeriod");
	}
}